# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, validator
from edgeimpulse_api.models.block_type import BlockType

class InputBlock(BaseModel):
    type: StrictStr = ...
    title: StrictStr = ...
    author: StrictStr = ...
    description: StrictStr = ...
    name: StrictStr = ...
    recommended: Optional[StrictBool] = None
    block_type: BlockType = Field(..., alias="blockType")
    __properties = ["type", "title", "author", "description", "name", "recommended", "blockType"]

    @validator('type')
    def type_validate_enum(cls, v):
        if v not in ('time-series', 'image', 'features'):
            raise ValueError("must validate the enum values ('time-series', 'image', 'features')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> InputBlock:
        """Create an instance of InputBlock from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> InputBlock:
        """Create an instance of InputBlock from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return InputBlock.construct(**obj)

        _obj = InputBlock.construct(**{
            "type": obj.get("type"),
            "title": obj.get("title"),
            "author": obj.get("author"),
            "description": obj.get("description"),
            "name": obj.get("name"),
            "recommended": obj.get("recommended"),
            "block_type": obj.get("blockType")
        })
        return _obj

