# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field

class TunerSpaceImpulse(BaseModel):
    parameters: Optional[Dict[str, Any]] = Field(None, description="Hyperparameters with potential values that can be used in any block in this impulse")
    input_blocks: List[Dict[str, Any]] = Field(..., alias="inputBlocks", description="Input Blocks that are part of this impulse")
    dsp_blocks: List[Dict[str, Any]] = Field(..., alias="dspBlocks", description="DSP Blocks that are part of this impulse")
    learn_blocks: List[List[Dict[str, Any]]] = Field(..., alias="learnBlocks", description="Learning Blocks that are part of this impulse")
    __properties = ["parameters", "inputBlocks", "dspBlocks", "learnBlocks"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TunerSpaceImpulse:
        """Create an instance of TunerSpaceImpulse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TunerSpaceImpulse:
        """Create an instance of TunerSpaceImpulse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return TunerSpaceImpulse.construct(**obj)

        _obj = TunerSpaceImpulse.construct(**{
            "parameters": obj.get("parameters"),
            "input_blocks": obj.get("inputBlocks"),
            "dsp_blocks": obj.get("dspBlocks"),
            "learn_blocks": obj.get("learnBlocks")
        })
        return _obj

